;
; Software Updater: 1.x
; Language:       English
; Platform:       WinXP/Vista
; Author:         S van Dragt <sander.vandragt@gmail.com>
;
; Based heavily on AutoHotKey updater by Rajat
; Script Function:
;	Updates software
;

#Include lastmod.ahk 
#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.
DebugMode = n
thisSoftware = "Software Updater"
IniFolder = Apps
AvailableUpdates = 0
InstalledUpdates = 0
Loop %IniFolder%\*.ini
{
   LocalInifile = %A_WorkingDir%\%IniFolder%\%A_LoopFileName%
   SplitPath, LocalInifile, iniFilePath
   RemoteIniFile = %A_Temp%\%iniFilePath%
   GoSub,Check
}
If AvailableUpdates = 0
	MsgBox,1,%thisSoftware%, No updates available`nTry again at a later time.
Else
	MsgBox,1,%thisSoftware%,Summary:`n`n%AvailableUpdates% updates available`n%InstalledUpdates% updates installed.`nplease send your comments to: sander.vandragt@gmail.com
ExitApp

;Subs and functions

Check:
	IniRead, iniURL, %LocalInifile%, Updates, iniURL ; local url 
	If iniURL = ERROR
		ErrorReadIni(001)

	IniRead, LastCheck, %LocalInifile%, Updates, LastCheck ;local LastCheck
	If LastCheck = ERROR
		LastCheck =
		
	UrlDownloadToFile, %iniURL%, %RemoteIniFile%
	If ErrorLevel
		ErrorDownloadIni(003)

	IniRead, Title, %LocalInifile%, Updates, Title ;local displayname
	If Title = ERROR
		SplitPath, RemoteInifile, Title ;on error take the filename from the online ini
		
	IniRead, URL, %RemoteIniFile%, Updates, URL ;online url
		If URL = ERROR
			ErrorReadIni(002)		
	LastMod := HttpQueryInfo(URL)

	If DebugMode = y
		MsgBox, %LastMod% > %LastCheck%  then update
	
	If LastMod > %LastCheck%
	{
		AvailableUpdates += 1
		TrayTip, %thisSoftware%, Update found for %Title%`nPlease Wait....
		; process ini
		IniRead, ProcessTitle, %RemoteIniFile%, Updates, Title ;processtitle
		If ProcessTitle = ERROR
			ErrorReadIni(008)

		MsgBox,1,%thisSoftware%, %Title%`nOnline Version`t: %LastMod% `nLocal Version`t: %LastCheck%`n`nPress OK to download and start the setup of the latest version.`nPress Cancel to Exit.
		
		IfMsgBox, Ok
		{
			SplitPath, URL, Filename
			TrayTip, %thisSoftware%, Downloading %Title%`nPlease Wait....
			;SetTimer, GetSize, 2000
			URLDownloadToFile, %URL%, %A_Temp%\%Filename%
			IfNotEqual, ErrorLevel, 0
			{
				TrayTip
				Msgbox,, %thisSoftware%, There was a problem downloading the installation file of %Title%.
			} 
			Else
				DownloadSuccess = y
			
			;SetTimer, GetSize, Off
			TrayTip, %thisSoftware%, Download complete...`n
			If DownloadSuccess = y
			{
				IfNotExist, %A_Temp%\%Filename%	
					ErrorNosetup(012)
				Msgbox,1,%thisSoftware%, Make sure that %Title% is not running before pressing Ok. Press Cancel to install at a later date.
				IfMsgBox, Ok
				{
					TrayTip, %thisSoftware%, Now running setup....
					RunWait, %A_Temp%\%Filename%,,UseErrorLevel
					If ErrorLevel
						ErrorRunWait(010)
					TrayTip, %thisSoftware%, Installation %Title% was successful`n Updating last versions...
					FileRecycle, %A_Temp%\%Filename%
					If ErrorLevel
						ErrorRecycleSetup(011)
					InstalledUpdates +=1
					IniWrite, %LastMod%, %RemoteIniFile%, Updates, LastCheck ;LastCheck
				}
			}
			; replace ini
			FileCopy, %RemoteIniFile%, %LocalInifile%,1
			If ErrorLevel
				ErrorCopyIni(005)

			FileRecycle, %RemoteIniFile%
			If ErrorLevel
				ErrorRecycleIni(006)
		}
		TrayTip

	}
return





KillProcess:
	Process, Exist, %ProcessName%
	IfNotEqual, ErrorLevel, 0
	{
		Loop
		{
			Process, Exist,  %ProcessName%
			IfEqual, ErrorLevel, 0, Break
			Process, Close,  %ProcessName%
			
		}
	}
return

GetSize:
	msgbox, %A_Temp%\%Filename%
	FileGetSize, FSize, %A_Temp%\%Filename%, K
	IfEqual, FSize, FSize0, Return
	IfNotEqual, ErrorLevel, 1
		TrayTip, %thisSoftware%, Downloading %Title%`nPlease Wait....`nDownloaded: %FSize0% of %FSize%
	FSize0 = %FSize%
Return


; Error Handling

ErrorReadIni(num)
{
	Msgbox, Problem reading ini file %LocalInifile%`nError %num%
	ExitApp
	return
}

ErrorDownloadIni(num)
{
	Msgbox, Problem downloading ini file`nError %num%
	ExitApp
return
}


ErrorCopyIni(num){
	Msgbox, Could not copy ini file, are there enough permissions?`nError %num%
	ExitApp
return
}

ErrorRecycleIni(num) {
	Msgbox, Could not delete old ini file, are there enough permissions?`nError %num%
	ExitApp
return
}

ErrorRunWait(num){
	Msgbox, Launching setup failed`nError %num%
	ExitApp
return
}

ErrorRecycleSetup(num){
	Msgbox, Deleting setup failed`nError %num%
	ExitApp
return
}

ErrorNosetup(num) {
	Msgbox, No Setup file found, cannot continue`nError %num%
	ExitApp
return
return
}